unit Kolon_u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Spin;

type
  TPOdk=Packed Record
    x1,y1,x2,y2,obr:SmallInt;
    zpet:Boolean;
  End;
  TOdkaz=Packed Record
    odk:Array[1..20] Of TPOdk;
    pocodk:Byte;
  End;
  TfHlavni = class(TForm)
    imgVpred: TImage;
    lVpred: TLabel;
    imgVzad: TImage;
    lVzad: TLabel;
    imgObsah: TImage;
    lObsah: TLabel;
    lKonec: TLabel;
    imgKonec: TImage;
    imgHLinka: TImage;
    imgDLinka: TImage;
    pObrazky: TPanel;
    imgObrazky: TImage;
    pOdkazy: TPanel;
    btnDefOdkaz: TButton;
    btnSmazOdkazy: TButton;
    lOdkazy: TLabel;
    lCObr: TLabel;
    cbZpet: TCheckBox;
    seCObr: TSpinEdit;
    lSourad: TLabel;
    imgZpet: TImage;
    lZpet: TLabel;
    Procedure ZmenObr(obr:Integer);
    Procedure EnDisZpet(enab:Boolean);
    Function GetOdkaz(x,y:Integer):SmallInt;
    Procedure LoadOdkazy;
    Procedure SaveOdkazy;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lVpredClick(Sender: TObject);
    procedure lVzadClick(Sender: TObject);
    procedure lObsahClick(Sender: TObject);
    procedure lZpetClick(Sender: TObject);
    procedure lKonecClick(Sender: TObject);
    procedure imgObrazkyMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgObrazkyMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgObrazkyMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnDefOdkazClick(Sender: TObject);
    procedure btnSmazOdkazyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
 end;

var
  fHlavni: TfHlavni;
  AppPath:String;
  AktualObr,OldObr,mx1,my1,mx2,my2:Integer;
  Odkaz:Array[0..1000] Of TOdkaz;
  mDown:Boolean;

Const MaxObr:Integer=63;

implementation

{$R *.DFM}
{$I-}

Procedure TfHlavni.ZmenObr(obr:Integer);
Begin
  With imgObrazky Do Begin
    Picture.LoadFromFile(AppPath+'obrazky\'+'obr'+IntToStr(obr)+'.bmp');
  End;
  lOdkazy.Caption:='Poet odkaz: '+IntToStr(Odkaz[obr].pocodk);
End;

Procedure TfHlavni.EnDisZpet(enab:Boolean);
Begin
  imgZpet.Visible:=enab; lZpet.Visible:=enab;
  imgVpred.Visible:=Not enab; lVpred.Visible:=Not enab;
  imgVzad.Visible:=Not enab; lVzad.Visible:=Not enab;
  fHlavni.Repaint;
End;

Function TfHlavni.GetOdkaz(x,y:Integer):SmallInt;
Var z:Integer;
Begin
  Result:=0;
  With Odkaz[AktualObr] Do Begin
    For z:=1 To pocodk Do
      If (x>=odk[z].x1) And (x<=odk[z].x2) And
         (y>=odk[z].y1) And (y<=odk[z].y2) Then Begin
        Result:=z; Break;
      End;  
  End;
End;

Procedure TfHlavni.LoadOdkazy;
Var f:File;
    res:Integer;
Begin
  FillChar(Odkaz,SizeOf(Odkaz),0);
  AssignFile(f,AppPath+'odkazy.dat');
  FileMode:=0; Reset(f,1);
  If IOResult=0 Then Begin
    BlockRead(f,Odkaz,SizeOf(Odkaz),res);
    CloseFile(f);
  End;
End;

Procedure TfHlavni.SaveOdkazy;
Var f:File;
    res:Integer;
Begin
  AssignFile(f,AppPath+'odkazy.dat');
  Rewrite(f,1);
  If IOResult=0 Then Begin
    BlockWrite(f,Odkaz,SizeOf(Odkaz),res);
    CloseFile(f);
  End;
End;

procedure TfHlavni.FormCreate(Sender: TObject);
begin
  mDown:=False; AktualObr:=0; OldObr:=0;
  AppPath:=ParamStr(0);
  While Not (AppPath[Length(AppPath)]='\') Do
    AppPath:=Copy(AppPath,1,Length(AppPath)-1);
  LoadOdkazy; EnDisZpet(False);
  ZmenObr(AktualObr);
end;

procedure TfHlavni.FormShow(Sender: TObject);
begin
  fHlavni.WindowState:=wsMaximized;
end;

procedure TfHlavni.lVpredClick(Sender: TObject);
begin
  If AktualObr<MaxObr Then Begin
    Inc(AktualObr); ZmenObr(AktualObr);
  End;
end;

procedure TfHlavni.lVzadClick(Sender: TObject);
begin
  If AktualObr>0 Then Begin
    Dec(AktualObr); ZmenObr(AktualObr);
  End;
end;

procedure TfHlavni.lObsahClick(Sender: TObject);
begin
  EnDisZpet(False); AktualObr:=1; ZmenObr(AktualObr);
end;

procedure TfHlavni.lZpetClick(Sender: TObject);
begin
  EnDisZpet(False); AktualObr:=OldObr; ZmenObr(AktualObr);
end;

procedure TfHlavni.lKonecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfHlavni.imgObrazkyMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var poz:SmallInt;
begin
  If pOdkazy.Visible Then Begin
    mx1:=X; my1:=Y; mx2:=X; my2:=Y; mDown:=True;
  End;
  If Button=mbLeft Then Begin
    poz:=GetOdkaz(X,Y);
    If poz<>0 Then Begin
      OldObr:=AktualObr;
      EnDisZpet(Odkaz[AktualObr].odk[poz].zpet);
      AktualObr:=Odkaz[AktualObr].odk[poz].obr;
      ZmenObr(AktualObr);
    End;
  End;
end;

procedure TfHlavni.imgObrazkyMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  If GetOdkaz(X,Y)<>0 Then imgObrazky.Cursor:=crHandPoint
  Else imgObrazky.Cursor:=crDefault;
  If pOdkazy.Visible Then Begin
    If mDown Then With imgObrazky.Canvas Do Begin
      Pen.Mode:=pmCopy;
      Pen.Color:=clRed;
      Rectangle(mx1,my1,X,Y);
    End;
    lSourad.Caption:='X: '+IntToStr(X)+' - Y: '+IntToStr(Y);
  End;
end;

procedure TfHlavni.imgObrazkyMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If pOdkazy.Visible Then Begin
    mx2:=X; my2:=Y; mDown:=False;
  End;
end;

procedure TfHlavni.btnDefOdkazClick(Sender: TObject);
begin
  With Odkaz[AktualObr] Do Begin
    If pocodk<20 Then Inc(pocodk);
    odk[pocodk].x1:=mx1; odk[pocodk].y1:=my1;
    odk[pocodk].x2:=mx2; odk[pocodk].y2:=my2;
    odk[pocodk].obr:=seCObr.Value;
    odk[pocodk].zpet:=cbZpet.Checked;
  End;
  SaveOdkazy; ZmenObr(AktualObr);
end;

procedure TfHlavni.btnSmazOdkazyClick(Sender: TObject);
begin
  FillChar(Odkaz[AktualObr],SizeOf(Odkaz[AktualObr]),0);
  SaveOdkazy; ZmenObr(AktualObr);
end;

end.
